// ҂̈⌾ t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

unsigned char buff[0x100*16*80];

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size) {
	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

bool fsave(char *_fname, int _adr, int _size) {
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(&buff[_adr], 1, _size, fp);
	fclose(fp);
	return true;
}

int main(int argc, char *argv[])
{
	char fname[FILENAME_MAX];
	int i;
	int id=0;
	int mus=0;

	if (argc != 2) {
		fprintf(stderr, "Usage: %s [d88file]\n",argv[0]);
		return 1;
	}

	if (!disk.SetFile(argv[1])) {
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	disk.SelectDisk(0);
	// Track 1ID̓ǂݍ
	id = disk.ReadID(0x01, buff, 4*6)/4;
	if (id==0) {
		fprintf(stderr, "Ή̃fBXN`ł.\n");
		return 1;
	}

	// IWi (N=4 x 3)
	if (buff[3]==4 && id==3) {
		// o[W
		disk.ReadDATA1(0, 0, 0, 1, 1, buff, 0x100);
		disk.SetRecordRange(0x01,0x03);
		switch (buff[0]) {
		case 0xcd:
			// OK
			printf("[Type A : Original]\n");
			fcut("OP1",  0x10, 0x08, 0x00, 0x01, 0x04, 0x0176, 0x0ac4);
			fcut("OP2",  0x0a, 0x05, 0x00, 0x02, 0x04, 0x06d7, 0x1174);
			fcut("EDPRG",0x09, 0x04, 0x01, 0x01, 0x04, 0x04c2, 0x0431);
			fcut("ED",   0x0a, 0x05, 0x00, 0x01, 0x04, 0x00f3, 0x0b60);
			break;

		case 0x21:
			// OK
			printf("[Type B : Original]\n");
			fcut("OP1",  0x11, 0x08, 0x01, 0x01, 0x04, 0x01a1, 0x0ac4);
			fcut("OP2",  0x0b, 0x05, 0x01, 0x02, 0x04, 0x0702, 0x1174);
			fcut("EDPRG",0x0a, 0x05, 0x00, 0x01, 0x04, 0x04c1, 0x0454);
			fcut("ED",   0x0b, 0x05, 0x01, 0x01, 0x04, 0x0115, 0x0b70);
			break;

		default:
			fprintf(stderr, "Ή̃fBXN`ł.\n");
			return 1;
		}
	}
	// obNAbv (N=3 x5, N=2 x1)
	else if (buff[3]==3 && id==6) {
		// o[W
		disk.ReadDATA1(0, 0, 0, 1, 1, buff, 0x100);
		disk.SetRecordRange(0x01,0x05);
		unsigned char *lp = buff;
		switch (buff[0]) {
		case 0xcd:
			// OK
			printf("[Type A : Backup]\n");
			memset(buff, 0x00, sizeof(buff));
			// OP1
			fcut("OP1", 0x10, 0x08, 0x00, 0x01, 0x03, 0x0176, 0x0ac4);
			// OP2
			disk.ReadDATA(0x0a, 0x05, 0x00, 0x04, 0x03, lp, 0x0800);
			lp+=0x800;
			disk.ReadDATA1(0x0a, 0x05, 0x00, 0x06, 0x02, lp, 0x0200);
			lp+=0x200;
			disk.ReadDATA1(0x42, 0x21, 0x00, 0x01, 0x03, lp, 0x0200);
			lp+=0x200;
			disk.ReadDATA(0x0b, 0x05, 0x01, 0x01, 0x03, lp, 0x1174+0x02d7-0x0c00);
			fsave("OP2", 0x02d7, 0x1174);
			//ED
			fcut("EDPRG", 0x09, 0x04, 0x01, 0x02, 0x03, 0x00c2, 0x0431);	// 0x63a0
			fcut("ED",    0x0a, 0x05, 0x00, 0x01, 0x03, 0x00f3, 0x0b60);	// 0x9000
			break;

		case 0x21:
			printf("[Type B : Backup]\n");
			memset(buff, 0x00, sizeof(buff));
			// OP1
			fcut("OP1", 0x11, 0x08, 0x01, 0x01, 0x03, 0x01a1, 0x0ac4);
			// OP2
			disk.ReadDATA(0x0b, 0x05, 0x01, 0x04, 0x03, lp, 0x0400);
			lp+=0x400;
			disk.ReadDATA(0x0b, 0x05, 0x01, 0x05, 0x03, lp, 0x0400);
			lp+=0x400;
			disk.ReadDATA1(0x42, 0x21, 0x00, 0x01, 0x03, lp, 0x0400);
			disk.ReadDATA1(0x0b, 0x05, 0x01, 0x06, 0x02, lp, 0x0200);
			lp+=0x400;
			disk.ReadDATA(0x0c, 0x06, 0x00, 0x01, 0x03, lp, 0x0876);
			fsave("OP2", 0x0302, 0x1174);
			//ED
			fcut("EDPRG", 0x0a, 0x05, 0x00, 0x02, 0x03, 0x00c1, 0x0454);	// 0x63a0
			fcut("ED",    0x0b, 0x05, 0x01, 0x01, 0x03, 0x0115, 0x0b70);	// 0x9000
			break;

		default:
			break;
		}
	}
	return 0;
}
